.INCLUDE "..\APPNOTES\1200DEF.INC"
;============================================================================
.DEF	TEMP=R16
.DEF	TMR_TEMP=R17
.DEF	STACK=R18
.DEF	KEYCODE=R19
.DEF	DEL0=R20
.DEF	DEL1=R21

.EQU	TMR_CONST=128
.EQU	ARMED=5
.EQU	DISARMED=6
;***PASSWORD***
.EQU	NUM0=1
.EQU	NUM1=5
.EQU	NUM2=5
;============================================================================
.MACRO	TEST_KEY
	SBR	TEMP,0B00001111
	CLT

	DEC	KEYCODE
	CPI	TEMP,0B01111111
	BREQ	END_KEY			;11-7-3
	
	DEC	KEYCODE
	CPI	TEMP,0B10111111
	BREQ	END_KEY			;10-6-2

	DEC	KEYCODE
	CPI	TEMP,0B11011111
	BREQ	END_KEY			;9-5-1
	
	DEC	KEYCODE
	CPI	TEMP,0B11101111
	BREQ	END_KEY			;8-4-0
	
	SET
END_KEY:	
.ENDM
;============================================================================

	.ORG	0
	RJMP	RESET
	.ORG	2
TMR_0:
	IN	STACK,0x3F
	SBIC	PORTD,ARMED
	RJMP	MUST_CLEAR
MUST_SET:
	SBI	PORTD,ARMED
	RJMP	GENER_OK
MUST_CLEAR:
	CBI	PORTD,ARMED
GENER_OK:
	LDI	TMR_TEMP,TMR_CONST
	OUT	TCNT0,TMR_TEMP
	OUT	0x3F,STACK
	RETI
;============================================================================
RESET:
	;INIT PORTS
	LDI	TEMP,0B00000111
	OUT	DDRB,TEMP

	LDI	TEMP,255
	OUT	PORTB,TEMP
	OUT	PORTD,TEMP

	SBI	DDRD,ARMED
	SBI	DDRD,DISARMED

	;INIT TIMER

	;MAIN CUCLE
MAIN:
	SBI	PORTD,ARMED
	CBI	PORTD,DISARMED
N0:
	RCALL	SCAN_KEY
	CPI	KEYCODE,255
	BREQ	N0
	CPI	KEYCODE,NUM0
	BRNE	N0
N1:
	RCALL	SCAN_KEY
	CPI	KEYCODE,255
	BREQ	N1
	CPI	KEYCODE,NUM1
	BRNE	N0
N2:
	RCALL	SCAN_KEY
	CPI	KEYCODE,255
	BREQ	N2
	CPI	KEYCODE,NUM2
	BRNE	N0
	
	CBI	PORTD,ARMED
	SBI	PORTD,DISARMED
	
N_ARMED:
	RCALL	SCAN_KEY
	CPI	KEYCODE,255
	BREQ	N_ARMED
	
	RJMP	MAIN
;=======================================
SCAN_KEY:
	LDI	KEYCODE,12
	;
	CBI	PORTB,0
	RCALL	SMALL_DELAY
	IN	TEMP,PINB
	SBI	PORTB,0
	TEST_KEY
	BRTC	KEY_PRESSED
	;
	CBI	PORTB,1
	RCALL	SMALL_DELAY
	IN	TEMP,PINB
	SBI	PORTB,1
	TEST_KEY
	BRTC	KEY_PRESSED
	;
	CBI	PORTB,2
	RCALL	SMALL_DELAY
	IN	TEMP,PINB
	SBI	PORTB,2
	TEST_KEY
	BRTC	KEY_PRESSED
	;
	LDI	KEYCODE,255
	RET
KEY_PRESSED:
	CBI	PORTD,ARMED
	RCALL	DELAY
	RCALL	DELAY
	SBI	PORTD,ARMED
	RET
;=======================================
SMALL_DELAY:
	LDI	DEL0,127
	RJMP	DEL_M0
DELAY:
	LDI	DEL0,255
DEL_M0:
	LDI	DEL1,255
DEL_M1:
	DEC	DEL1
	BRNE	DEL_M1
	DEC	DEL0
	BRNE	DEL_M0
	RET
;============================================================================